#
# PGP auth
#

# $Id: pgp_auth.rb,v 1.1 2002/11/12 17:34:49 elca Exp elca $

require "thread"
require "timeout"

require "util.rb"

if ENV["PGPOPT"] != nil
  PGPOPT = ENV["PGPOPT"]
else
  PGPOPT = ""
end

class DnsAuthPGP
  def initialize(answer)
    name = dnsstr_to_str(answer["a"]).downcase
    /^sec\-auth\-pgp\-\-\.([0-9a-f\.]+)\.-\-\.([a-z0-9\-\.]+)$/ =~ name

    hexsig = $1.tr(".", "")
    base = $2
    ttl = "\0\0\0\0"

    if hexsig == nil || base == nil
      @format_valid = false
      return
    end

    @packet = str_to_dnsstr(base) + answer["a_type"] + answer["a_class"] +
      ttl + [answer["data"].size].pack("n") + answer["data"]

    @binsig = [hexsig.tr(".", "")].pack("H*")

    if !(@binsig.size == 65 || @binsig.size == 64)
      @format_valid = false
      return
    end

    @format_valid = true
  end

  def valid()
    if @format_valid == false || @binsig == nil
      ML.log("PGP bad format")
      return false
    end

    good = false
    valid = false

    #p @binsig
    #p @packet

    begin
      timeout(20) {
	# GPG $B$H%Q%$%W%i%$%s%b!<%I$GBPOC$7$F%G!<%?$N@5Ev@-$r3NG'$9$k(B
	open("|gpg #{PGPOPT} --batch --status-fd 1 --logger-fd 1 -q --pipemode", "w+") {
	  |fd|

	  fd.print("@<@B")
	  fd.print(@binsig.gsub("@", "@@"))
	  fd.print("@t")
	  fd.print(@packet.gsub("@", "@@")) # some error appears if text includes '@'...
	  fd.print("@.@>")
	  fd.each {
	    |l|
	    break if /^gpg: @@ not allowed in current state/ =~ l # gpg bug ?
	    break if /error/ =~l
	    next  if /^gpg:/ =~ l

	    ML.log(l.chop)

	    valid = true if /^\[GNUPG:\] VALIDSIG / =~ l
	    good  = true if /^\[GNUPG:\] GOODSIG / =~ l

	    good = false if /^\[GNUPG:\] ERRSIG / =~ l
	    good = false if /^\[GNUPG:\] BADSIG / =~ l
	    good = false if /^\[GNUPG:\] EXPSIG / =~ l
	    good = false if /^\[GNUPG:\] EXPKEYSIG / =~ l

	    break if /^\[GNUPG:\] NODATA/ =~ l
	    break if /^\[GNUPG:\] END_STREAM/ =~ l
	  }
	}
      }
    rescue TimeoutError
      ML.log("GPG timeout")
    rescue StandardError
      ML.log("GPG error")
    end

    if good == true && valid == true
      ML.log("PGP good")
      return true
    else
      ML.log("PGP bad")
      return false
    end
  end
end

# end
